;; -------------------------------- +
;;  Mouse-Hook                      |
;; -------------------------------- +

include header.inc

;; -- Code section ----------------
_text segment 'CODE'

;; --------------------------------
	include subrouts/wndproc.asm
	include subrouts/other.asm
;; --------------------------------

start				proc
	call	InitCommonControls

	push	0
	call	GetModuleHandle
	mov		dword ptr[MainModuleHandle],eax
	mov		dword ptr[MainWndClass.hInstance],eax

	push	IDI_WARNING
	push	0
	call	LoadIcon
	mov		dword ptr[MainWndClass.hIcon],eax
	test	eax,eax
	jz		@@error

	push	IDC_ARROW
	push	0
	call	LoadCursor
	mov		dword ptr[MainWndClass.hCursor],eax

	push	offset MainWndClass
	call	RegisterClass

	push	SM_CXSCREEN
	call	GetSystemMetrics
	mov		ebx,eax

	push	SM_CYSCREEN
	call	GetSystemMetrics
	mov		ecx,eax
	sub		ebx,WINDOW_WIDTH
	sub		ecx,WINDOW_HEIGHT
	shr		ebx,1
	shr		ecx,1

	xor		eax,eax
	push	eax
	push	dword ptr[MainModuleHandle]
	push	eax
	push	eax
	push	WINDOW_HEIGHT
	push	WINDOW_WIDTH
	push	ecx
	push	ebx
	push	WS_VISIBLE or WS_OVERLAPPEDWINDOW and (not (WS_SIZEBOX or WS_MAXIMIZEBOX))
	push	offset MainWndName
	push	offset MainWndClassName
	push	WS_EX_TOPMOST
	call	CreateWindowEx
	test	eax,eax
	jz		@@error

	push	eax
	call	UpdateWindow

	lea		ebx,[msg]
	@@msg_loop:
	xor		eax,eax
	push	eax
	push	eax
	push	eax
	push	ebx
	call	GetMessage
	test	eax,eax
	jz		@@end_msg_loop

	push	ebx
	push	ebx
	call	TranslateMessage
	call	DispatchMessage

	jmp		@@msg_loop

	@@end_msg_loop:
	@@exit_program:
	push	dword ptr[msg.wParam]
	call	ExitProcess

	@@error:
	push	1
	call	ExitProcess

ret
start				endp

_text ends

;; -- Data section ----------------
_data segment dword 'DATA'
	include data/data.asm
	include data/strings.asm
_data ends

_bss  segment dword 'BSS'
	include data/notinit.asm
_bss  ends

end start