;; -------------------------------- +
;;  other.asm                       |
;; -------------------------------- +

;; -- Set child windows font ------ +
;; -------------------------------- +
SetChildWindowsFont		proc
	push	esi
	push	edi

	xor		esi,esi
	mov		edi,ChildWindowsNum

	@@set_font:
	push	esi
	shl		esi,2

	push	1
	push	dword ptr[MainFontNormal]
	push	WM_SETFONT
	push	dword ptr[ChildWndHandles+esi]
	call	SendMessage

	pop		esi
	inc		esi
	dec		edi
	jnz		@@set_font

	pop		edi
	pop		esi
ret
SetChildWindowsFont		endp

;; -- Set font for Edit windows --- +
;;                                  |
;;   in:                            |
;;      AL - 0 - normal font        |
;;           1 - italic font        |
;; -------------------------------- +
SetEditWindowsFont		proc
	push	ebx
	push	esi

	test	al,al
	jz		@@normal_font

	mov		esi,dword ptr[MainFontItalic]
	jmp		@@set_font

	@@normal_font:
	mov		esi,dword ptr[MainFontNormal]

	@@set_font:
	xor		ebx,ebx
	mov		cl,EditWindowsNum

	@@set_font_loop:
	push	ecx

	push	1
	push	esi
	push	WM_SETFONT
	push	dword ptr[EditWindowsHandles+ebx*4]
	call	SendMessage

	pop		ecx
	inc		ebx
	dec		cl
	jnz		@@set_font_loop

	pop		esi
	pop		ebx
ret
SetEditWindowsFont		endp

InitEditWindows			proc
	xor		al,al		;; normal font
	call	SetEditWindowsFont
ret
InitEditWindows			endp

ClearEditWindows		proc
	push	ebx

	xor		ebx,ebx
	mov		cl,EditWindowsNum
	@@set_text:
	push	ecx

	push	offset null_str
	push	dword ptr[EditWindowsHandles+ebx*4]
	call	SetWindowText

	pop		ecx
	inc		ebx
	dec		cl
	jnz		@@set_text

	xor		al,al
	inc		al		;; italic font
	call	SetEditWindowsFont

	pop		ebx
ret
ClearEditWindows		endp
