;; -------------------------------- +
;;  wndproc.asm                     |
;; -------------------------------- +

MainWndProc		proc \
	hWnd:				dword,
	Msg:				dword,
	wParam:				dword,
	lParam:				dword

	local lfont:		LOGFONT
	;; --------------------------------
	push	ebx
	push	esi

	mov		eax,dword ptr[Msg]

	cmp		eax,WM_MOUSEHOOK
	jz		@@msg_wm_mouhook

	cmp		eax,WM_COMMAND
	jz		@@msg_wm_command

	cmp		eax,WM_DESTROY
	jz		@@msg_wm_destroy

	cmp		eax,WM_CREATE
	jz		@@msg_wm_create

	push	dword ptr lParam
	push	dword ptr wParam
	push	dword ptr Msg
	push	dword ptr hWnd
	call	DefWindowProc
	jmp		@@return

	;; --------------------------------
	@@msg_wm_mouhook:
	mov		ebx,dword ptr[wParam]
	cmp		dword ptr[LastHookHwnd],ebx
	jz		@@return0

	mov		dword ptr[LastHookHwnd],ebx

	;; -- set 'Module handle' ---
	push	GCL_HMODULE
	push	ebx
	call	GetClassLong
	push	eax
	push	offset fmt_Hex
	push	offset CommonBuffer
	call	wsprintf
	add		esp,12
	push	offset CommonBuffer
	push	dword ptr[hwnd_edit0]
	call	SetWindowText

	;; -- set 'Window name' ---
	push	offset CommonBuffer
	push	sizeof CommonBuffer
	push	WM_GETTEXT
	push	ebx
	call	SendMessage
	test	eax,eax
	jnz		@@mouhook_name_ok
	mov		byte ptr[CommonBuffer],0
	@@mouhook_name_ok:
	push	offset CommonBuffer
	push	dword ptr[hwnd_edit1]
	call	SetWindowText

	;; -- set 'Window handle' -
	push	ebx
	push	offset fmt_Hex
	push	offset CommonBuffer
	call	wsprintf
	add		esp,12
	push	offset CommonBuffer
	push	dword ptr[hwnd_edit2]
	call	SetWindowText

	;; -- set 'Window style' ---
	push	GWL_ID
	push	ebx
	call	GetWindowLong
	push	eax
	push	offset fmt_Hex
	push	offset CommonBuffer
	call	wsprintf
	add		esp,12
	push	offset CommonBuffer
	push	dword ptr[hwnd_edit3]
	call	SetWindowText

	;; -- set 'Class name' ----
	push	sizeof CommonBuffer
	push	offset CommonBuffer
	push	ebx
	call	GetClassName
	test	eax,eax
	jnz		@@mouhook_class_ok
	mov		byte ptr[CommonBuffer],0
	@@mouhook_class_ok:
	push	offset CommonBuffer
	push	dword ptr[hwnd_edit4]
	call	SetWindowText

	;; -- set 'Window proc' ---
	push	GCL_WNDPROC
	push	ebx
	call	GetClassLong
	push	eax
	push	offset fmt_Hex
	push	offset CommonBuffer
	call	wsprintf
	add		esp,12
	push	offset CommonBuffer
	push	dword ptr[hwnd_edit5]
	call	SetWindowText

	;; -- set 'Window style' ---
	push	GWL_STYLE
	push	ebx
	call	GetWindowLong
	push	eax
	push	offset fmt_Hex
	push	offset CommonBuffer
	call	wsprintf
	add		esp,12
	push	offset CommonBuffer
	push	dword ptr[hwnd_edit6]
	call	SetWindowText

	;; -- set 'Window exstyle' ---
	push	GWL_EXSTYLE
	push	ebx
	call	GetWindowLong
	push	eax
	push	offset fmt_Hex
	push	offset CommonBuffer
	call	wsprintf
	add		esp,12
	push	offset CommonBuffer
	push	dword ptr[hwnd_edit7]
	call	SetWindowText

	jmp		@@return0
	;; --------------------------------

	;; --------------------------------
	@@msg_wm_create:
	lea		eax,[lfont]
	push	sizeof LOGFONT
	push	eax
	call	RtlZeroMemory

	mov		dword ptr[lfont.lfHeight],16
	mov		dword ptr[lfont.lfWidth],8
	mov		dword ptr[lfont.lfWeight],FW_NORMAL
	mov		dword ptr[lfont.lfClipPrecision],CLIP_DEFAULT_PRECIS
	mov		dword ptr[lfont.lfQuality],DEFAULT_QUALITY

	lea		eax,[lfont.lfFaceName]
	push	sizeof font_cournew
	push	offset font_cournew
	push	eax
	call	RtlMoveMemory

	lea		eax,[lfont]
	push	eax
	push	eax

	;; -- create normal font --
	call	CreateFontIndirect
	mov		dword ptr[MainFontNormal],eax

	;; -- create italic font --
	mov		dword ptr[lfont.lfItalic],1
	call	CreateFontIndirect
	mov		dword ptr[MainFontItalic],eax

	;; ------------------------
	mov		cl,8
	xor		ebx,ebx
	mov		esi,10
	@@create_text_windows:
	push	ecx

	xor		eax,eax
	push	eax
	push	dword ptr[MainModuleHandle]
	push	eax
	push	dword ptr[hWnd]
	push	16
	push	200
	push	esi
	push	4
	push	WS_CHILD or WS_VISIBLE
	push	dword ptr[str_text_array+ebx*4]
	push	offset cls_static
	push	eax
	call	CreateWindowEx
	mov		dword ptr[hwnd_text0+ebx*4],eax

	pop		ecx
	add		esi,22
	inc		ebx
	dec		cl
	jnz		@@create_text_windows
	;; ------------------------

	;; ------------------------
	mov		cl,8
	xor		ebx,ebx
	mov		esi,8
	@@create_edit_windows:
	push	ecx

	xor		eax,eax
	push	eax
	push	dword ptr[MainModuleHandle]
	push	eax
	push	dword ptr[hWnd]
	push	20
	push	WINDOW_WIDTH-140
	push	esi
	push	130
	push	WS_CHILD or WS_VISIBLE or ES_AUTOHSCROLL or ES_READONLY
	push	eax
	push	offset cls_edit
	push	WS_EX_CLIENTEDGE
	call	CreateWindowEx
	mov		dword ptr[hwnd_edit0+ebx*4],eax

	pop		ecx
	add		esi,22
	inc		ebx
	dec		cl
	jnz		@@create_edit_windows
	;; ------------------------

	;; -- line-separator ------
	xor		eax,eax
	push	eax
	push	dword ptr[MainModuleHandle]
	push	eax
	push	dword ptr[hWnd]
	push	1
	push	WINDOW_WIDTH-20
	push	WINDOW_HEIGHT-65
	push	4
	push	WS_CHILD or WS_VISIBLE or SS_ETCHEDHORZ
	push	offset str_SetHook
	push	offset cls_static
	push	eax
	call	CreateWindowEx

	;; ------------------------
	xor		ebx,ebx
	push	ebx
	push	dword ptr[MainModuleHandle]
	push	IDB_SETHOOK
	push	dword ptr[hWnd]
	push	23
	push	100
	push	WINDOW_HEIGHT-60
	push	5
	push	WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON
	push	offset str_SetHook
	push	offset cls_button
	push	0
	call	CreateWindowEx
	mov		dword ptr[hwnd_btn0],eax

	push	ebx
	push	dword ptr[MainModuleHandle]
	push	IDB_ABOUT
	push	dword ptr[hWnd]
	push	23
	push	50
	push	WINDOW_HEIGHT-60
	push	WINDOW_WIDTH-125
	push	WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON
	push	offset str_About
	push	offset cls_button
	push	0
	call	CreateWindowEx
	mov		dword ptr[hwnd_btn1],eax

	push	ebx
	push	dword ptr[MainModuleHandle]
	push	IDB_EXIT
	push	dword ptr[hWnd]
	push	23
	push	50
	push	WINDOW_HEIGHT-60
	push	WINDOW_WIDTH-70
	push	WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON
	push	offset str_ExitProg
	push	offset cls_button
	push	0
	call	CreateWindowEx
	mov		dword ptr[hwnd_btn2],eax
	;; ------------------------

	mov		byte ptr[Flags],bl

	call	SetChildWindowsFont
	call	ClearEditWindows
	jmp		@@return0
	;; --------------------------------

	;; --------------------------------
	@@msg_wm_command:
	xor		eax,eax
	mov		ax,word ptr[wParam]

	cmp		ax,IDB_SETHOOK
	jz		@@command_sethook

	cmp		ax,IDB_ABOUT
	jz		@@command_about

	cmp		ax,IDB_EXIT
	jz		@@msg_wm_destroy

	jmp		@@return0

	;; ------------------------
	@@command_sethook:
	xor		al,al
	inc		al
	test	byte ptr[Flags],al
	jz		@@command_sethook_set

	and		byte ptr[Flags],11111110b

	push	offset str_SetHook
	push	dword ptr[hwnd_btn0]
	call	SetWindowText

	call	RemoveHook
	call	ClearEditWindows
	jmp		@@return0

	@@command_sethook_set:
	or		byte ptr[Flags],al

	push	offset str_DelHook
	push	dword ptr[hwnd_btn0]
	call	SetWindowText

	call	InitEditWindows
	mov		eax,dword ptr[hWnd]
	call	InstallHook
	jmp		@@return0
	;; ------------------------

	;; ------------------------
	@@command_about:
	push	MB_ICONINFORMATION
	push	offset str_About
	push	offset str_AboutText
	push	dword ptr[hWnd]
	call	MessageBox

	jmp		@@return0
	;; ------------------------

	;; --------------------------------

	;; --------------------------------
	@@msg_wm_destroy:
	cmp		byte ptr[Flags],1
	jnz		@@destroy

	call	RemoveHook

	@@destroy:
	push	0
	call	PostQuitMessage
	;; --------------------------------

	@@return0:
	xor		eax,eax

	@@return:
	pop		esi
	pop		ebx
	ret 16
MainWndProc		endp
